/********************************************************************************************
 * FEAR: Flexible Embodied Animat 'Rchitecture
 *
 * Copyright (c) 2002-2004 Cerebral Creations, All Rights Reserved.
 *
 * FEAR is free software; you can redistribute it and/or modify it under the terms of the GNU
 * General Public License (GPL), as published by the Free Software Foundation. These files
 * are distributed in the hope that they will be useful, but WITHOUT ANY WARRANTY, without
 * even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * attached LICENSE file for details, or read http://www.gnu.org/copyleft/gpl.html.
 *
 * 
 * File:            demos\book\jwha3\Base.h
 * Note:            This file is generated automatically by the tools. Do not edit!
 *
 ********************************************************************************************/

#pragma once


// ------------------------------------------------------------------------------------------
// Essential Inclusions
// ------------------------------------------------------------------------------------------
#include <fear/services/execute.hpp>
#include <fear/body/motion/relative.hpp>
#include <fear/body/physics/relative.hpp>
#include <fear/body/vision/space.hpp>
#include <fear/body/vision/symbolic.hpp>
#include <fear/services/debug/visual.hpp>
#include <vector>


namespace fear {




// ==========================================================================================
// Jwha3BrainBase
// ------------------------------------------------------------------------------------------
/// The base class stores all the data used by the implementation.  This is defined in the 
/// XML model, so the mechanical manipulation of data can be generated automatically. 
// ==========================================================================================
class Jwha3BrainBase
{

// ------------------------------------------------------------------------------------------
// Life-Cycle Management
// ------------------------------------------------------------------------------------------

protected:

    /**
     * Automatically generated constructor.
     */
	Jwha3BrainBase()
	{
	} // Jwha3BrainBase()

	/**
	 * Meta-coded destructor.
	 */
	virtual ~Jwha3BrainBase() 
	{
	} // ~Jwha3BrainBase()


// ------------------------------------------------------------------------------------------
// Interface Handling 
// ------------------------------------------------------------------------------------------

    body::motion::iRelative* motion; ///< motion hook
    body::physics::iRelative* physics; ///< physics hook
    body::vision::iSpace* space; ///< space hook
    body::vision::iSymbolic* visual; ///< visual hook
	services::debug::iVisual* debug; ///< debug hook


}; // class Jwha3BrainBase


} // namespace fear

