/******************************************************************************\
|*        Name: Brain.cpp
|*
|*        Date: 03/06/2005
|*
|* Description: Brain for jwha3 animat
|*              Do a figure 8.  If you see the Human Player run away.  Jump
|*              if you crash into a wall, etc...
|*
|*     Project: Assignment 3
|*
|*         Due: 03/07/2005
|*
|*    Location: D:\FEAR\demos\book\jwha3
|*
|*       Class: Mon & Wed. 6:10-9:00 CIS 588 Computer Game Design 2 Winter 2005
|*
|*   Functions:
|*
|*         Key: I - Input parameter
|*              O - Output parameter
|*              R - What function returns
|*
|********************************** History ************************************
|* Hamill, John W.     03/06/2005  CREATED
|* Hamill, John W.     03/06/2005  Started with Spin and modified to make a
|*                                 figure 8 instead of a circle.
|* Hamill, John W.     03/06/2005  Created code to make animat detect a human
|*                                 player with code from Brutus.
|* Hamill, John W.     03/06/2005  Made animat turn 180 deg. and run away.
|*                                 If animat hit a wall it will turn some more
|*                                 and try to run some more.
|*                                 
\******************************************************************************/

/*******************************************************************************
 * AI Game Development: Learning & Reactive Behaviors
 *
 * Copyright (c) 2002-2003 Alex J. Champandard, All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License (GPL) as published
 * by the Free Software Foundation.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY, without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the attached LICENSE file for details.
 *
 * 
 * File:            Jwha3BrainBase.h
 * Description:   Implementation of the Brain class which needs to be
 *                  coded manually.
 * Author:         Alex J. Champandard
 * Contact:         alex@ai-depot.com
 * 
 ******************************************************************************/
#include "Brain.h"
#include <fear/random.hpp>

using namespace fear;
using namespace body::motion;
using namespace std;

// ------------------------------------------------------------------------------------------
// Common Routines
// ------------------------------------------------------------------------------------------
#include "../../common/Combat.cpp"

const float k_StepSize = 32.0f;
//const float k_StepSize75 = 32.0f * 0.75f;
const float k_StepSize75 = 24.0f;

// ============================================================================
// Think
// ----------------------------------------------------------------------------
/// This is the main entry point for AI control.  When this animat must
/// think, the framework calls this function of the Brain.  Execution should
/// be as short as possible, returning within limited time to increase
/// responsiveness of the system.
// ============================================================================
void Jwha3Brain::Think()
{
    using namespace services::debug;

   // ----JWH Code Start-------------------------------------------------------
   static int iLoopCounter = 0;
   //   // Counter from 0 - 23 to determine whether to turn clockwise or counter
   //   // clockwise.

   static bool bRunAway       = false;
   //   // true  - Run away because there is a human player near
   //   // false - Don't run away there is not human player near
   static int iRunAwayCounter = 0;
   //   // Counter for animat to run away for n number of frames

   // Find nearest Player (Not an robot animat but a animat controled by
   // a human player.  Get in this mode by hitting the 'P' key.
   bool bPlayerNear           = FindNearestPlayer(*this,mxvPlayer,NULL);

   // Amount to turn. < 15.0 Max
   float fAmtToTurn = 0.0f;

   // Make animat do a figure 8
   //motion->Jump();
   //motion->Duck();

   // If human player not near, and not running away
   if (bPlayerNear == false && bRunAway == false)
   {

      // Run in a figure 8
//      motion->Jump();
      motion->Step(Forward);
//      motion->Step(Backward);
//      motion->Step(Left);
//      motion->Step(Right);


      // Test if doing the counter clockwise part of the figure 8
      // 12 turns of 30 degress is 360 degrees and a full circle counter clockwise
      if (iLoopCounter < 12)
      {
         // Turn 30 degrees Counter Clockwise for the 1st 12 moves of 24 moves
         motion->Turn(30.0f);

      // Do the clockwise part of the figure 8
      // 12 turns of -30 degress is -360 degrees and a full circle clockwise
      } else {
         // Turn 30 degrees         Clockwise for the 2nd 12 moves of 24 moves
         motion->Turn(-30.0f);
      } // end if

      // Update a counter
      iLoopCounter++;

      // Test if counter needs to be set back to 0
      // This will start the figure 8 back a the beginning
      if (iLoopCounter == 24)
      {
         iLoopCounter = 0;

         printf("LoopCounter = 24 p = %d\n", bPlayerNear);
      }

   }
   // If human player near
   else if (bPlayerNear == true && bRunAway == false)

   {
      bRunAway        = true;

      iRunAwayCounter = 40;

      // Find a position 180 deg. away from Human Player
      mxvAway1.x = -mxvPlayer.x;
      mxvAway1.y = -mxvPlayer.y;
      mxvAway1.z = 0.0f;

      mxvAway1.Normalise();


      // Draw a 4 units long line that is 180 deg. away from the Human Player and 46 units away.
      debug->Line(mxvAway1, mxvAway2, Green );

      // Determin which direction to turn
      if (mxvPlayer.y > 0.0f)
      {
         // Turn CCW less then 180.0 deg.
         mbTurnCCW = true;
      }
      else
      {
         // Turn CW less then 180.0 deg.
         mbTurnCCW = false;
      }

      // Calculate the number of degrees to turn. Convert Radians to Degrees
      // mfDegToTurn = asin(mxvAway1.y) * 360.0f / (2.0f * PI);
      mfDegToTurn = fabs(asin(mxvAway1.y) * 57.29577952f);

      // Make deg. between 0 & 180.
      for(; mfDegToTurn > 180.0f;)
      {
         mfDegToTurn -= 180.0f;
      }

      // Turn around to face away form Human Player
      mfDegToTurn = 180.0f - mfDegToTurn;

      // Get a 2nd point to draw a line with
      mxvAway2 = mxvAway1;

      // Size to length 46 units (1/2 body size + one step => 16 units + 30 units)
      mxvAway1.x *= 0.0f;
      mxvAway1.y *= 0.0f;

      // Create the 2nd point to draw a line with.  Line will be 4 units long.
      mxvAway2.x *= 192.0f;
      mxvAway2.y *= 192.0f;

      mxvAway1.z = 80.0f;
      mxvAway2.z = 80.0f;

      // Print some debugging info
      printf(
         "Player Found  p=%d .x=%f, .y=%f, .z=%f\n",
         bPlayerNear, 
         mxvPlayer.x,  
         mxvPlayer.y,  
         mxvPlayer.z
      );
      printf(
         "     mxvAway1 p=%d .x=%f, .y=%f, .z=%f\n", 
         bPlayerNear, 
         mxvAway1.x, 
         mxvAway1.y, 
         mxvAway1.z
      );
      printf(
         "     mxvAway2 p=%d .x=%f, .y=%f, .z=%f\n", 
         bPlayerNear, 
         mxvAway2.x, 
         mxvAway2.y, 
         mxvAway2.z
      );
      printf(
         "     Turn CCW=%d  Deg. To Turn=%f\n", 
         mbTurnCCW,
         mfDegToTurn
      );
   }
   // running away
   else
   {
      // Turn if needed
      if (mfDegToTurn >  0.0f)
      {
         // Calc. the amount to turn.  Not more then 15 deg.
         if (mfDegToTurn > 15.0f)
         {
            fAmtToTurn   = 15.0f;
            mfDegToTurn -= fAmtToTurn; 
         }
         else
         {
            fAmtToTurn  = mfDegToTurn;
            mfDegToTurn = 0.0f;
         }

         if (mbTurnCCW == true)
         {
            // Turn CCW
            motion->Turn( fAmtToTurn);
         }
         else
         {
            // Turn CW
            motion->Turn(-fAmtToTurn);
         }
      }
      else
      {
// Need code to test for collision
//         motion->Stop();
//         motion->Jump();

         // Start From Bouncer Brain.cpp------------------------------
         // determine how far the body moved since the last update
         Vec3f moved; 
         Angles turned;
         // query the physics sensor for relative movement
         physics->GetMovement( moved );
         // check recent body rotation too
         turned = physics->GetOrientation();

          // Check if the forward movement was less than expected, indicating a 
          // collision.  Ideally it would be a value of 100%, but less than 75%
          // forward movement is a good measure that's not overly precise.
         if (moved.x < k_StepSize75)
         {
         // End From Bouncer ------------------------------
            if (mbTurnCCW == true)
            {
               // Turn CCW
               motion->Turn( 5.0f);
            }
            else
            {
               // Turn CW
               motion->Turn(-5.0f);
            }
         }
         else
         {
            // Turn so Jump always happens below.  Doesn't work. :(
            //motion->Turn(0.0f);

            // Turn then turn back so Jump always happens below.  Doesn't work. :(
            //motion->Turn(0.1f); motion->Turn(-0.1f);

            // Move back then jump. Doesn't work :(
            //motion->Step(Backward);motion->Jump();
         }

         // Turn so Jump always happens below.  Doesn't work. :(
         //motion->Turn(0.0f);motion->Jump();motion->Step(Forward);

//         motion->Jump();
//         motion->Step(Forward);

         // Every 2nd loop jump.  Works :)
         if (iRunAwayCounter % 2 == 0)
         {
            motion->Jump();
         }
         else
         {
            motion->Step(Forward);
         }
      }

      // Decrement run away counter
      --iRunAwayCounter;

      // Stop running away after counter runs out
      if (iRunAwayCounter == 0)
      {
         bRunAway = false;
      }

      // Draw a 4 units long line that is 180 deg. away from the Human Player and 46 units away.
      debug->Line(mxvAway1, mxvAway2, Green );
   }

   // Colors defined in 
   // D:\FEAR\fear\services\debug\Debug.hpp
   // D:\FEAR\platform\quake2\Fear\BackendDefinition.cpp
   // D:\FEAR\platform\quake2\Fear\f_interface.h
   // D:\FEAR\modules\body\vision\src\VisionDefinition.cpp .h

   // Line Above head
   debug->Line(Vec3f(0.0f,0.0f,35.0f), Vec3f(45.3f,-45.3f,35.0f), Green ); // -45 deg 64.0f line
   debug->Line(Vec3f(0.0f,0.0f,35.0f), Vec3f(64.0f, 00.0f,35.0f), Yellow); //  Line forward
   debug->Line(Vec3f(0.0f,0.0f,35.0f), Vec3f(45.3f, 45.3f,35.0f), Blue  ); //  45 deg 64.0f line

   // Line at Feet
   debug->Line(Vec3f(0.0f,0.0f,00.0f), Vec3f(45.3f,-45.3f,00.0f), Red   ); // -45 deg 64.0f line
   debug->Line(Vec3f(0.0f,0.0f,00.0f), Vec3f(45.3f, 45.3f,00.0f), Orange); //  45 deg 64.0f line

   // ----JWH Code End---------------------------------------------------------
   
} // Think()



// ============================================================================
// Jwha3Brain
// ----------------------------------------------------------------------------
/// Constructor calls the Base to perform automatic initialisation,
/// as generated by the tools.  The Architecture is also initialised as it
/// is required later.  Any custom variables can be constructed here too.
// ============================================================================
Jwha3Brain::Jwha3Brain()
:   Jwha3BrainBase(),
   Architecture("Jwha3Brain")
{
} // Jwha3Brain()



// ============================================================================
// ~Jwha3Brain
// ----------------------------------------------------------------------------
/// Virtual destructor should free all memory of custom variables.
/// The destructor of the Base is called automatically, along with the
/// Architecture's destructor.
// ============================================================================
Jwha3Brain::~Jwha3Brain()
{
} // ~Jwha3Brain()



/******************************************************************************
 * Revisions:
 *               $Log: Brain.cpp,v $
 *               Revision 1.6  2005/02/23 John W. Hamill
 *               Copied Spin and created Jwha3
 *               Make animat do a figure 8 instead of just a circle
 *               in Jwha3Brain::Think()               
 *
 *               Revision 1.5  2004/04/07 22:53:45  alexjc
 *               Changes to accomodate the new location of the header files
 *               
 *               Revision 1.4  2004/02/29 11:29:41  alexjc
 *               Minor interface changes to support euler angles and stack returns
 *               
 *               Revision 1.3  2003/11/18 23:54:09  alexjc
 *               Cleaned up the code, removing redundant functions.
 *               
 *               Revision 1.2  2003/10/01 21:32:55  alexjc
 *               matches specification for documentation extraction and
 *             processing tools
 *               
 *               Revision 1.1  2003/09/11 00:48:43  alexjc
 *               working version of Jwha3
 *               
 ******************************************************************************/

